<template>
    <div class="content-header" v-loading.fullscreen.lock="fullscreenLoading">
        <div class="container-fluid">
            <div class="row mb-2">
                <div class="col-sm-6">
                    <h1 class="m-0">Documentos</h1>
                </div><!-- /.col -->
                <div class="col-sm-6">
                    <button class="btn btn-primary" style="float: right" @click.prevent="clearFields();active_crear = true;">
                        Agregar
                    </button>
                </div>
            </div><!-- /.row -->
        </div><!-- /.container-fluid -->

        <div class="card">
            <template>
                <div class="center">
                    <vs-table>
                        <template #header>
                            <vs-input v-model="search" border placeholder="Buscar" />
                        </template>
                        <template #thead>
                            <vs-tr>                                
                                <vs-th sort @click="listas = $vs.sortData($event, listas, 'DOC_NOMBRE')">
                                    Nombre
                                </vs-th>
                                <vs-th sort @click="listas = $vs.sortData($event, listas, 'DOC_CODIGO')">
                                    Codigo
                                </vs-th>
                                <vs-th sort @click="listas = $vs.sortData($event, listas, 'DOC_CONTENIDO')">
                                    Contenido
                                </vs-th>
                                <vs-th sort @click="listas = $vs.sortData($event, listas, 'TIP_NOMBRE')">
                                    Tipo
                                </vs-th>
                                <vs-th sort @click="listas = $vs.sortData($event, listas, 'PRO_NOMBRE')">
                                    Proceso
                                </vs-th>
                                <vs-th sort @click="listas = $vs.sortData($event, listas, 'DOC_ID')">
                                    ID
                                </vs-th>
                                <vs-th>-</vs-th>
                            </vs-tr>
                        </template>
                        <template #tbody>
                            <vs-tr :key="i" v-for="(tr, i) in $vs.getPage($vs.getSearch(listas, search), page, max)" :data="tr">
                                <vs-td>
                                    {{ tr.DOC_NOMBRE }}
                                </vs-td>
                                <vs-td>
                                    {{ tr.DOC_CODIGO }}
                                </vs-td>
                                <vs-td>
                                    {{ tr.DOC_CONTENIDO }}
                                </vs-td>
                                <vs-td>
                                    {{ tr.TIP_NOMBRE }}
                                </vs-td>
                                <vs-td>
                                    {{ tr.PRO_NOMBRE }}
                                </vs-td>
                                <vs-td>
                                    {{ tr.DOC_ID }}
                                </vs-td>
                                <vs-td>
                                    <div class="btn-group">
                                        <button type="button" class="btn btn-primary" @click.prevent="showModalUpdate(tr)">
                                            <i class="fa fa-edit"></i>
                                        </button>
                                        <button type="button" class="btn btn-danger" @click.prevent="eliminarRegistro(tr)">
                                            <i class="fa fa-trash"></i>
                                        </button>
                                    </div>
                                </vs-td>
                            </vs-tr>
                        </template>
                        <template #footer>
                            <vs-pagination v-model="page" :length="$vs.getLength($vs.getSearch(listas, search), max)"/>
                        </template>
                    </vs-table>
                </div>
            </template>
        </div>

        <vs-dialog overflow-hidden v-model="active_crear">
            <template #header>
                <h4 class="not-margin text-primary">
                    Crear Documento
                </h4>
            </template>
            <div class="con-form">
                <vs-input label-placeholder="Nombre" v-model="nombre" />
                <br/>
                <vs-input label-placeholder="Contenido" v-model="contenido"/>
                <br/>
                <label class="mt-2">Tipos</label>
                <vs-select v-model="tipo">
                    <vs-option v-for="(item, i) in tipos" :key="i" :label="item.TIP_NOMBRE" :value="item.TIP_ID">
                        {{ item.TIP_NOMBRE }}
                    </vs-option>
                </vs-select>
                <br/>
                <label class="mt-2">Procesos</label>
                <vs-select v-model="proceso">
                    <vs-option v-for="(item, i) in procesos" :key="i" :label="item.PRO_NOMBRE" :value="item.PRO_ID">
                        {{ item.PRO_NOMBRE }}
                    </vs-option>
                </vs-select>
            </div>
            <template #footer>
                <div class="footer-dialog">
                    <vs-button block @click.prevent="submitSave()">
                        Guardar
                    </vs-button>
                </div>
            </template>
        </vs-dialog>

        <vs-dialog overflow-hidden v-model="active_update">
            <template #header>
                <h4 class="not-margin text-primary">
                    Editar
                </h4>
            </template>
            <div class="con-form">
                <vs-input label-placeholder="Nombre" v-model="nombre" />
                <br/>
                <vs-input label-placeholder="Contenido" v-model="contenido"/>
                <br/>
                <label class="mt-2">Tipos</label>
                <vs-select v-model="tipo">
                    <vs-option v-for="(item, i) in tipos" :key="i" :label="item.TIP_NOMBRE" :value="item.TIP_ID">
                        {{ item.TIP_NOMBRE }}
                    </vs-option>
                </vs-select>
                <br/>
                <label class="mt-2">Procesos</label>
                <vs-select v-model="proceso">
                    <vs-option v-for="(item, i) in procesos" :key="i" :label="item.PRO_NOMBRE" :value="item.PRO_ID">
                        {{ item.PRO_NOMBRE }}
                    </vs-option>
                </vs-select>
            </div>
            <template #footer>
                <div class="footer-dialog">
                    <vs-button block @click.prevent="submitUpdate()">
                        Actualizar
                    </vs-button>
                </div>
            </template>
        </vs-dialog>
    </div>
</template>

<script>
export default {
    data: () => ({
        fullscreenLoading: false,
        page: 1,
        max: 5,
        search: '',
        listas: [],
        tipos: [],
        procesos: [],
        active_crear: false,
        active_update: false,
        idf: 0,
        nombre: '', 
        codigo: [],
        tipo: [],
        proceso: '',
        contenido: ''
    }),
    mounted() {
        this.getLista();
    },
    methods: {
        getLista() {
            this.fullscreenLoading = true;
            axios.get('/documentos/index')
            .then(response => {
                this.listas = response.data;
                this.getListaTipos();
                this.getListaProcesos();
                this.fullscreenLoading = false;
            });
        },
        getListaTipos() {
            this.fullscreenLoading = true;
            axios.get('/tipos/index')
            .then(response => {
                this.tipos = response.data;
                this.fullscreenLoading = false;
            });
        },
        getListaTipos() {
            this.fullscreenLoading = true;
            axios.get('/tipos/index')
            .then(response => {
                this.tipos = response.data;
            });
        },
        getListaProcesos() {
            this.fullscreenLoading = true;
            axios.get('/procesos/index')
            .then(response => {
                this.procesos = response.data;
            });
        },
        submitSave() {
            let tipo = this.tipos.filter(tipos => tipos.TIP_ID === this.tipo)[0];
            let proceso = this.procesos.filter(procesos => procesos.PRO_ID === this.proceso)[0];

            this.fullscreenLoading = true;
            axios.post('/documentos/save', {
                codigo: tipo.TIP_PREFIJO+'-'+proceso.PRO_PREFIJO,
                nombre: this.nombre,
                contenido: this.contenido,
                tipo_id: this.tipo,
                proceso_id: this.proceso
            })
            .then(() => {
                this.active_crear = false;
                this.clearFields();
                this.getLista();
            });
        },
        showModalUpdate(item) {
            this.idf = item.PRO_ID;
            this.nombre = item.DOC_NOMBRE;
            this.codigo = item.DOC_CODIGO;
            this.contenido = item.DOC_CONTENIDO;
            this.tipo = item.DOC_ID_TIPO;
            this.proceso = item.DOC_ID_PROCESO;
            this.active_update = true;
        },
        submitUpdate() {
            let tipo = this.tipos.filter(tipos => tipos.TIP_ID === this.tipo)[0];
            let proceso = this.procesos.filter(procesos => procesos.PRO_ID === this.proceso)[0];

            this.fullscreenLoading = true;
            axios.post('/documentos/update', {
                codigo: tipo.TIP_PREFIJO+'-'+proceso.PRO_PREFIJO,
                nombre: this.nombre,
                contenido: this.contenido,
                tipo_id: this.tipo,
                proceso_id: this.proceso
            })
            .then(() => {
                this.active_update = false;
                this.clearFields();
                this.getLista();
            });
        },
        eliminarRegistro(item) {
            this.$swal.fire({
                title: '¿Estás seguro de eliminar el siguiente registro '+item.DOC_CODIGO+'?',
                icon: 'warning',
                showCancelButton: true,
                confirmButtonText: 'Eliminar',
                cancelButtonText: 'Cancelar',
            }).then((result) => {
                if (result.isConfirmed) {
                    this.submitDelete(item);
                }
            });
        },
        submitDelete(item) {
            this.fullscreenLoading = true;
            axios.post('/documentos/delete', {
                id: item.DOC_ID
            })
            .then(() => {
                this.active_update = false;
                this.getLista();
            });
        },
        clearFields(){
            this.nombre = '';
            this.codigo = '';
            this.contenido = '';
            this.tipo = '';
            this.proceso = '';
        }
    }
}
</script>